using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Data;
using System.Threading;
using System.Text.RegularExpressions;
using System.IO;

using DShowNET;
using DShowNET.Device;


namespace DirectShowTest
{

	public class CaptureForm : System.Windows.Forms.Form 
	{
		#region Definition of Windows Forms
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Panel videoPanel;
		private System.Windows.Forms.PictureBox pictureBoxCapture;
		private System.Windows.Forms.Button buttonCaptureStill;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button buttonSaveStill;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button buttonSaveMovie;
		private System.Windows.Forms.Button buttonCaptureMovie;
		private System.Windows.Forms.Button buttonPlayMovie;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Button buttonOptionDetail;
		private System.Windows.Forms.Button buttonOption;
		private System.Windows.Forms.Panel videoPanelCapture;
		private System.Windows.Forms.Label labelCaptureMovie;
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.videoPanel = new System.Windows.Forms.Panel();
			this.labelCaptureMovie = new System.Windows.Forms.Label();
			this.pictureBoxCapture = new System.Windows.Forms.PictureBox();
			this.buttonCaptureStill = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.buttonSaveStill = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.buttonPlayMovie = new System.Windows.Forms.Button();
			this.buttonSaveMovie = new System.Windows.Forms.Button();
			this.buttonCaptureMovie = new System.Windows.Forms.Button();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.videoPanelCapture = new System.Windows.Forms.Panel();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.buttonOptionDetail = new System.Windows.Forms.Button();
			this.buttonOption = new System.Windows.Forms.Button();
			this.videoPanel.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.SuspendLayout();
			// 
			// videoPanel
			// 
			this.videoPanel.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.labelCaptureMovie});
			this.videoPanel.Location = new System.Drawing.Point(8, 24);
			this.videoPanel.Name = "videoPanel";
			this.videoPanel.Size = new System.Drawing.Size(320, 240);
			this.videoPanel.TabIndex = 0;
			// 
			// labelCaptureMovie
			// 
			this.labelCaptureMovie.Font = new System.Drawing.Font("lr SVbN", 18F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.labelCaptureMovie.ForeColor = System.Drawing.Color.Red;
			this.labelCaptureMovie.Location = new System.Drawing.Point(112, 104);
			this.labelCaptureMovie.Name = "labelCaptureMovie";
			this.labelCaptureMovie.Size = new System.Drawing.Size(88, 23);
			this.labelCaptureMovie.TabIndex = 0;
			this.labelCaptureMovie.Text = "Be";
			this.labelCaptureMovie.Visible = false;
			// 
			// pictureBoxCapture
			// 
			this.pictureBoxCapture.Location = new System.Drawing.Point(16, 24);
			this.pictureBoxCapture.Name = "pictureBoxCapture";
			this.pictureBoxCapture.Size = new System.Drawing.Size(320, 240);
			this.pictureBoxCapture.TabIndex = 1;
			this.pictureBoxCapture.TabStop = false;
			// 
			// buttonCaptureStill
			// 
			this.buttonCaptureStill.Location = new System.Drawing.Point(8, 16);
			this.buttonCaptureStill.Name = "buttonCaptureStill";
			this.buttonCaptureStill.Size = new System.Drawing.Size(64, 23);
			this.buttonCaptureStill.TabIndex = 7;
			this.buttonCaptureStill.Text = "Be";
			this.buttonCaptureStill.Click += new System.EventHandler(this.buttonCaptureStill_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.buttonSaveStill,
																					this.buttonCaptureStill});
			this.groupBox1.Location = new System.Drawing.Point(104, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(168, 48);
			this.groupBox1.TabIndex = 10;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Î~";
			// 
			// buttonSaveStill
			// 
			this.buttonSaveStill.Location = new System.Drawing.Point(88, 16);
			this.buttonSaveStill.Name = "buttonSaveStill";
			this.buttonSaveStill.Size = new System.Drawing.Size(64, 23);
			this.buttonSaveStill.TabIndex = 8;
			this.buttonSaveStill.Text = "ۑ";
			this.buttonSaveStill.Click += new System.EventHandler(this.buttonSaveStill_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.buttonPlayMovie,
																					this.buttonSaveMovie,
																					this.buttonCaptureMovie});
			this.groupBox2.Location = new System.Drawing.Point(280, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(240, 48);
			this.groupBox2.TabIndex = 11;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "";
			// 
			// buttonPlayMovie
			// 
			this.buttonPlayMovie.Location = new System.Drawing.Point(88, 16);
			this.buttonPlayMovie.Name = "buttonPlayMovie";
			this.buttonPlayMovie.Size = new System.Drawing.Size(64, 23);
			this.buttonPlayMovie.TabIndex = 9;
			this.buttonPlayMovie.Text = "Đ";
			this.buttonPlayMovie.Click += new System.EventHandler(this.buttonPlayMovie_Click);
			// 
			// buttonSaveMovie
			// 
			this.buttonSaveMovie.Location = new System.Drawing.Point(168, 16);
			this.buttonSaveMovie.Name = "buttonSaveMovie";
			this.buttonSaveMovie.Size = new System.Drawing.Size(64, 23);
			this.buttonSaveMovie.TabIndex = 8;
			this.buttonSaveMovie.Text = "ۑ";
			this.buttonSaveMovie.Click += new System.EventHandler(this.buttonSaveMovie_Click);
			// 
			// buttonCaptureMovie
			// 
			this.buttonCaptureMovie.Location = new System.Drawing.Point(8, 16);
			this.buttonCaptureMovie.Name = "buttonCaptureMovie";
			this.buttonCaptureMovie.Size = new System.Drawing.Size(64, 23);
			this.buttonCaptureMovie.TabIndex = 7;
			this.buttonCaptureMovie.Text = "BeJn";
			this.buttonCaptureMovie.Click += new System.EventHandler(this.buttonCaptureMovie_Click);
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.videoPanel});
			this.groupBox3.Location = new System.Drawing.Point(0, 48);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(344, 272);
			this.groupBox3.TabIndex = 12;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "vr[";
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.videoPanelCapture,
																					this.pictureBoxCapture});
			this.groupBox4.Location = new System.Drawing.Point(360, 48);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(344, 272);
			this.groupBox4.TabIndex = 13;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Lv`";
			// 
			// videoPanelCapture
			// 
			this.videoPanelCapture.Location = new System.Drawing.Point(12, 24);
			this.videoPanelCapture.Name = "videoPanelCapture";
			this.videoPanelCapture.Size = new System.Drawing.Size(320, 240);
			this.videoPanelCapture.TabIndex = 2;
			this.videoPanelCapture.Visible = false;
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.buttonOptionDetail,
																					this.buttonOption});
			this.groupBox5.Location = new System.Drawing.Point(528, 0);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(176, 48);
			this.groupBox5.TabIndex = 14;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "J̐ݒ";
			// 
			// buttonOptionDetail
			// 
			this.buttonOptionDetail.Location = new System.Drawing.Point(88, 16);
			this.buttonOptionDetail.Name = "buttonOptionDetail";
			this.buttonOptionDetail.Size = new System.Drawing.Size(80, 23);
			this.buttonOptionDetail.TabIndex = 8;
			this.buttonOptionDetail.Text = "xȐݒ";
			this.buttonOptionDetail.Click += new System.EventHandler(this.buttonOptionDetail_Click);
			// 
			// buttonOption
			// 
			this.buttonOption.Location = new System.Drawing.Point(8, 16);
			this.buttonOption.Name = "buttonOption";
			this.buttonOption.Size = new System.Drawing.Size(72, 23);
			this.buttonOption.TabIndex = 7;
			this.buttonOption.Text = "{ݒ";
			this.buttonOption.Click += new System.EventHandler(this.buttonOption_Click);
			// 
			// CaptureForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(712, 326);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBox5,
																		  this.groupBox2,
																		  this.groupBox1,
																		  this.groupBox3,
																		  this.groupBox4});
			this.Name = "CaptureForm";
			this.Text = "CaptureForm";
			this.videoPanel.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		enum GUIModes {All, StillRecord, MovieRecord, MoviePlay};
		public const string DummyFileName = "./tmp.avi";

		DSCapture dsCapture1;
    	DSCaptureMovie dsCaptureMovie;
		DSPlay dsPlay;

		Thread timerThread;
		Thread animationThread;

		public const int WM_GRAPHNOTIFY = 0x00008001;//DirectShowCxgŗpEChEYbZ[WD

		public CaptureForm()
		{
			InitializeComponent();

			timerThread = null;
			dsCapture1 = new DSCapture(this, this.videoPanel,0);

			if(!dsCapture1.isActive) 
				this.Dispose();
			
			return;
		}

		protected override void Dispose( bool disposing )
		{
			if(dsCapture1 != null)
				dsCapture1.CloseInterfaces();

			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			if(timerThread != null)
			{
				timerThread.Abort();
				timerThread = null;
			}

			if(File.Exists(DummyFileName))
			{
				File.Delete(DummyFileName);
			}

			base.Dispose( disposing );
		}

		public Image PictureBoxImage
		{
			set{pictureBoxCapture.Image = value;}
			get{return pictureBoxCapture.Image;}
		}

		[MTAThread]
		static void Main() 
		{
			CaptureForm form = new CaptureForm();
			try
			{
				if(form != null)
				{
					Application.Run(form);
				}
				else
				{
					Application.ExitThread();
					Application.Exit();
				}
			}
			catch(Exception e)
			{
			}
		}


		private void buttonOption_Click(object sender, System.EventArgs e)
		{
			dsCapture1.ShowPropertyPages();
		}

		private void buttonOptionDetail_Click(object sender, System.EventArgs e)
		{
			dsCapture1.ShowDetailPropertyPages();
		}

		private void buttonCaptureStill_Click(object sender, System.EventArgs e)
		{
			videoPanelCapture.Visible = false;
			pictureBoxCapture.Visible = true;
			CaptureStillImage();
		}
	
		private void CaptureStillImage()
		{
			if(timerThread != null)
			{
				timerThread.Abort();
				timerThread = null;
			}
	
			ChangeGuiMode(GUIModes.StillRecord);
			timerThread = new Thread(new ThreadStart(this.CaptureStillWorker));
			timerThread.Start();	
		}

		private void CaptureStillWorker()
		{
			try
			{	
				dsCapture1.StartGrabber();
				while(!(dsCapture1.isUpdated))
				{
					Thread.Sleep(10);
				}
				dsCapture1.isUpdated = false;				
			}
			catch(Exception e)
			{
				//MessageBox.Show(e.ToString());
			}	
			ChangeGuiMode(GUIModes.All);
			return;
		}

		private void buttonSaveStill_Click(object sender, System.EventArgs e)
		{
			string filename;
			int filterIndex;
			SaveFileDialog saveDialog = new SaveFileDialog();

			saveDialog.Filter = "Jpg File (*.jpg)|*.jpg |PngFile (*.png)|*.png |Bitmap File (*.bmp)|*.bmp" ;
			saveDialog.RestoreDirectory = true ;
			
			if(pictureBoxCapture.Image ==null)
			{
				MessageBox.Show("݃Lv`ĂÎ~͂܂D");
				return;
			}

			if(saveDialog.ShowDialog() == DialogResult.OK)
			{
				filename = saveDialog.FileName; 
				filterIndex = saveDialog.FilterIndex;
				ImageFormat [] imageFormats = new ImageFormat[3]{ImageFormat.Jpeg, ImageFormat.Png, ImageFormat.Bmp};
				pictureBoxCapture.Image.Save(filename, imageFormats[filterIndex-1]);
				return;	
			}

			return;
		}

		private void buttonCaptureMovie_Click(object sender, System.EventArgs e)
		{
			pictureBoxCapture.Visible = false;
			videoPanelCapture.Visible = true;

			if(buttonCaptureMovie.Text == "BeJn")
			{
				ChangeGuiMode(GUIModes.MovieRecord);

				dsCapture1.CloseInterfaces();
				dsCapture1 = null;

				labelCaptureMovie.Visible = true;
				if(animationThread == null)
				{
					animationThread = new Thread(new ThreadStart(UpdateTextAnimation));
					animationThread.Start();
				}
				dsCaptureMovie = new DSCaptureMovie(this, videoPanelCapture,0);
				buttonCaptureMovie.Text = "Be~";
			}
			else
			{
				labelCaptureMovie.Visible = false;
				
				if(animationThread != null && animationThread.IsAlive)
				{
					animationThread.Abort();
					animationThread = null;
				}

				groupBox4.BackColor = Color.FromArgb(255,220,220);
				
				dsCaptureMovie.CloseInterfaces();
				dsCaptureMovie = null;
				dsCapture1 = new DSCapture(this, videoPanel,0);
				buttonCaptureMovie.Text = "BeJn";
				
				ChangeGuiMode(GUIModes.All);
			}
			return;
		}

		private void buttonPlayMovie_Click(object sender, System.EventArgs e)
		{
						
			if(!File.Exists(DummyFileName))
			{
				MessageBox.Show("݃Lv`Ă铮͂܂D");
				return;
			}

			if(buttonPlayMovie.Text == "Đ")
			{		
				ChangeGuiMode(GUIModes.MoviePlay);
				if(dsPlay == null)
				{
					dsPlay = new DSPlay(this, videoPanelCapture);
				}
				buttonPlayMovie.Text = "~";
			}
			else
			{
				if(dsPlay != null)
				{
					dsPlay.CloseInterfaces();
					dsPlay = null;
				}
				buttonPlayMovie.Text = "Đ";
				ChangeGuiMode(GUIModes.All);
			}
		}

		private void buttonSaveMovie_Click(object sender, System.EventArgs e)
		{		
			string filename;
			
			SaveFileDialog saveDialog = new SaveFileDialog();

			saveDialog.Filter = "Avi File (*.avi)|*.avi";
			saveDialog.RestoreDirectory = true ;
			
			if(!File.Exists(DummyFileName))
			{
				MessageBox.Show("݃Lv`Ă铮͂܂D");
				return;
			}

			if(saveDialog.ShowDialog() == DialogResult.OK)
			{
				filename = saveDialog.FileName; 
				File.Copy(DummyFileName, filename, true);
			}

			return;
		}

		//GUȈԂ؂ւ
		private void ChangeGuiMode(GUIModes mode)
		{
			if(mode == GUIModes.All)
			{
				buttonCaptureMovie.Enabled = true;
				buttonCaptureStill.Enabled = true;
				buttonOption.Enabled = true;
				buttonOptionDetail.Enabled = true;
				buttonPlayMovie.Enabled = true;
				buttonSaveMovie.Enabled = true;
				buttonSaveStill.Enabled = true;
			}
			else if( mode == GUIModes.MoviePlay)
			{
				buttonPlayMovie.Enabled = true;

				buttonCaptureMovie.Enabled = false;
				buttonCaptureStill.Enabled = false;
				buttonOption.Enabled = false;
				buttonOptionDetail.Enabled = false;
				buttonSaveMovie.Enabled = false;
				buttonSaveStill.Enabled = false;
			}

			else if( mode == GUIModes.MovieRecord)
			{
				buttonCaptureMovie.Enabled = true;

				buttonCaptureStill.Enabled = false;
				buttonOption.Enabled = false;
				buttonOptionDetail.Enabled = false;
				buttonPlayMovie.Enabled = false;
				buttonSaveMovie.Enabled = false;
				buttonSaveStill.Enabled = false;
			}
			else if(mode==GUIModes.StillRecord)
			{
				buttonCaptureMovie.Enabled = false;
				buttonCaptureStill.Enabled = false;
				buttonOption.Enabled = false;
				buttonOptionDetail.Enabled = false;
				buttonPlayMovie.Enabled = false;
				buttonSaveMovie.Enabled = false;
				buttonSaveStill.Enabled = false;

			}
			return;
		}

		//WindowsCxg̏
		protected override void WndProc(ref Message m)
		{

			if(m.Msg == WM_GRAPHNOTIFY)
			{
				this.OnGraphNotify();				
				return;
			}	
			base.WndProc(ref m);
		}
		
		//DirectShowCxg̏
		public void OnGraphNotify()
		{
			DsEvCode code;
			int param1, param2, result =0;
			
			while(result == 0)
			{
				result = dsPlay.mediaEvent.GetEvent(out code,out param1, out param2, 0);
				
				//̖߂͏dvDYƁCAvP[VƋID
				if(result < 0) break;
				
				result = dsPlay.mediaEvent.FreeEventParams(code, param1, param2);
				
				if(code == DsEvCode.Complete )
				{

					this.buttonPlayMovie.Text = "Đ";
					if(dsPlay != null)
					{
						dsPlay.CloseInterfaces();
						dsPlay = null;	
					}
					ChangeGuiMode(GUIModes.All);
					break;
				}
				else if(code == DsEvCode.UserAbort)
				{
					break;
				}
				
			}
		}

		//[r[BẽAj[V\D
		private void UpdateTextAnimation()
		{
			int red = 255, green = 255, blue = 255;
			bool direction = false;
			try
			{
				while(true)
				{
					groupBox4.BackColor = Color.FromArgb(red,green,blue);
					labelCaptureMovie.ForeColor = Color.FromArgb(red,green,blue);
					if(direction)
					{
						if(green >= 255)
						{
							direction = false;
						}
						else
						{
							green++;
							blue++;
						}
					}
					else
					{
						if(green<= 0)
						{
							direction = true;
						}
						else
						{
							green--;
							blue--;
						}
					}			
					Thread.Sleep(5);
				}
			}
			catch(Exception e)
			{
				//MessageBox.Show(e.ToString());
			}
			return;
		}
	}
}
